/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/


/*
Sample client to illustrate the use of the CAVERNnet_datapack_c class.
*/

#include "CAVERN.hxx"
#include <stdio.h>

void main (int argc, char *argv[])
{
	int dataSize;
	char *receiveBuffer;

	char receivedChar;
	int receivedInt;
	long receivedLong;
	float receivedFloat;
	double receivedDouble;
	float* floatArray = new float[4];
    CAVERNnet_datapack_c packer;
	char receivedStr[8];

	CAVERNinit();
	CAVERNnet_tcpClient_c *client = new CAVERNnet_tcpClient_c;
	if (argc < 2){
		printf("Usage: %s machine_name\n",argv[0]);
		exit(1);
	}
	
	if (!client->connectToServer(argv[1], 9999)){
		printf("Can not connect to server\n");
		exit(1);
	}

	dataSize=packer.sizeof_char()+packer.sizeof_int()+packer.sizeof_float()+packer.sizeof_double() + packer.sizeof_long() + packer.sizeof_char(8) + packer.sizeof_float()*4;

	receiveBuffer=new char[dataSize];
	client->read(receiveBuffer, &dataSize,CAVERNnet_tcpClient_c::BLOCKING);
	packer.initUnpack(receiveBuffer,dataSize);
	packer.unpackFloat(&receivedFloat);
	packer.unpackInt(&receivedInt);
	packer.unpackDouble(&receivedDouble);
	packer.unpackChar(&receivedChar);
	packer.unpack(receivedStr,8);
	packer.unpackFloatArray(floatArray, 4);
	packer.unpackLong(&receivedLong);
    
	printf("Received Char: %c\n",receivedChar);
	printf("Received Int: %d\n",receivedInt);
	printf("Received Long: %ld\n",receivedLong);
	printf("Received Float: %f\n",receivedFloat);
	printf("Received Double: %f\n",receivedDouble);
	printf("Received String: %s\n",receivedStr);
    printf("Received Float Array - with the floats: ");
    for(int i=0; i<4; i++)
        printf("%f\t", floatArray[i]);
                   
	client->close();
	delete receiveBuffer;

}
