/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/
#include "CAVERN.hxx"
#include <stdio.h>

void main (int argc, char *argv[])
{
    const int SIZE = 4;
	int i;

	CAVERNinit();
	CAVERNnet_extendedTcpClient_c *client = new CAVERNnet_extendedTcpClient_c;
	if (argc < 2){
		printf("Usage: %s machine_IP_address\n",argv[0]);
		exit(1);
	}
	
        if (client->connectToServer(argv[1], 8566) <= 0) {
		printf("Cannot connect to server\n");
		exit(1);
	}

	char receivedChar;
	client->readChar(receivedChar, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Char: %c\n", receivedChar);

	int receivedInt;
	client->readInt(receivedInt, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Int: %d\n", receivedInt);

	int receivedIntArray[SIZE];
	client->readIntArray(receivedIntArray, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
    printf("Received Int Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %d\n", i, receivedIntArray[i]);

	int32 receivedInt32 = 23493233;
	printf("Received Int32: %d\n", receivedInt32);
	client->readInt32(receivedInt32, CAVERNnet_tcpClient_c::BLOCKING);

	int32 receivedInt32Array[SIZE];
	client->readInt32Array(receivedInt32Array, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Int32 Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %d\n", i, receivedInt32Array[i]);

#if (_MIPS_SZLONG==64) 
	int64 receivedInt64 = 102039483920;
	client->readInt64(receivedInt64, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Int64: %ld\n", receivedInt64);

	int64 receivedInt64Array[SIZE] = { 100000000000, 200000000000, 30000000000, 40000000000 };
	client->writeInt64Array(receivedInt64Array, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Int64 Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %ld\n", i, receivedInt64Array[i]);
#endif

	long receivedLong;
	client->readLong(receivedLong, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Long: %ld\n",receivedLong);

	long receivedLongArray[SIZE];
	client->readLongArray(receivedLongArray, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Long Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %ld\n", i, receivedLongArray[i]);

	float receivedFloat;
	client->readFloat(receivedFloat, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Float: %f\n",receivedFloat);

	float receivedFloatArray[SIZE];
	client->readFloatArray(receivedFloatArray, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Float Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %f\n", i, receivedFloatArray[i]);

	double receivedDouble;
	client->readDouble(receivedDouble, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Double: %f\n",receivedDouble);

	double receivedDoubleArray[SIZE];
	client->readDoubleArray(receivedDoubleArray, SIZE, CAVERNnet_tcpClient_c::BLOCKING);
	printf("Received Double Array\n");
	for (i = 0; i < SIZE; i++) printf("array[%d] = %lf\n", i, receivedDoubleArray[i]);
}
