/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERN.hxx"

#ifdef WIN32
#include <iostream>
#else
#include <iostream.h>
#endif

main( int a_iArgc, char *a_pcArgv[] )
{
  if( a_iArgc != 5 )
    {
      printf("usage: %s <remote host> <remote port> <psocket size> <send buffer size>\n",a_pcArgv[0]);
      exit(1);
    }
  char *pcRemoteName = a_pcArgv[1];
  int iRemotePort = atoi( a_pcArgv[2] );
  int iPSocketSize = atoi( a_pcArgv[3] );
  int iBufferSize = atoi( a_pcArgv[4] );

  char *pcBuffer = new char[iBufferSize];

  CAVERNinit();

  memset( pcBuffer, 65, iBufferSize );

  CAVERNnet_parallelTcpClient_c client;

  cout << "Trying to Connect!" << endl;

  if (client.connectToServer(pcRemoteName, iRemotePort, iPSocketSize) ==
          CAVERNnet_parallelTcpClient_c::FAILED) {
      cout << "cannot connect to the server " << pcRemoteName << endl;
      exit(1);
  }

  cout << "Connected" << endl;
  
  int j=0;
  client.write( pcBuffer, &iBufferSize );
  cout << "Done Sending" << endl;

  delete pcBuffer;
}

  
