/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERN.hxx"

#include <stdlib.h>

#ifdef WIN32
#define sleep(seconds) Sleep(seconds * 1000)
#endif

main(int argc, char** argv)
{
#if (defined(__sgi) && (_MIPS_SZLONG==64)) || defined(CAVERN_SIXTY_FOUR_BIT_FILE_SYSTEM)
	CAVERNinit();

	CAVERNnet_remoteFileIOServer64_c server;

	if (argc > 1 && argc < 3) {
		printf("Usage: server [NeighborServerName CacheLocally]\n");
		printf("NeighborServerName: Valid internet address of a host you want to connect to if files\n");
		printf("                    do not exist in this machine\n");
		printf("CacheLocally:       0 or 1. 0 won't save the file downloaded from the NeighborServerName\n");
		printf("                    locally for later use. 1 will save the downloaded file.\n");
		exit(1);
	}
	else {
		if (argc > 1) {
		    int cache = atoi(argv[2]);
		    printf("argv[2] = %d\n", cache);
			server.init(CAVERNnet_remoteFileIOServer64_c::DEFAULT_PORT, argv[1], CAVERNnet_remoteFileIOServer64_c::DEFAULT_PORT, cache);
		}
		else 
			server.init();
	}

	while(1) {
		// Set it up so that a new thread is spawned for each
		// client's request.
		server.process(CAVERNnet_remoteFileIOServer64_c::NON_THREADED);
		sleep(1);
	}
#endif
}
