/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERN.hxx"

#ifdef WIN32
#define timeb _timeb
#define ftime _ftime

#include <sys\timeb.h>
#else
#include <sys/timeb.h>
#endif


main(int argc, char** argv)
{
	CAVERNinit();

	CAVERNnet_remoteParallelFileIOClient32_c client;
	
	int day, mon, year, hour, min, sec;
	int day1, mon1, year1, hour1, min1, sec1;
    if (argc < 4)
    {
        printf("\nInsufficient number of arguments - usage: client <hostname> <localfilename> <remotefilename>\n");
        exit(1);
    }
    
    int result = client.getRemoteDateTime(argv[1], argv[3], &day, &mon, &year, &hour, &min, &sec);
    if (result == CAVERNnet_remoteParallelFileIOClient32_c::FILE_ERROR)
        printf("\nFile error\n");
    if (result == CAVERNnet_remoteParallelFileIOClient32_c::INVALID_COMMAND)
        printf("\nInvalid command\n");
    if (result == CAVERNnet_remoteParallelFileIOClient32_c::OK)    
	    printf("Remote file %s date/time stamp: %02d/%02d/%02d %02d:%02d:%02d\n", argv[3], mon, day, year, hour, min, sec);

    struct timeb tStartTime, tEndTime;
    ftime(&tStartTime);
	client.download(argv[1], argv[2], argv[3], 10);
	ftime(&tEndTime);

        float fElapsed = tEndTime.time - tStartTime.time;
	fElapsed += (float) ((float) (tEndTime.millitm - tStartTime.millitm) / 1000);

	printf("Approximate download time in seconds = %f\n", fElapsed);

	client.getLocalDateTime(argv[2], &day1, &mon1, &year1, &hour1, &min1, &sec1);

	printf("Local file %s date/time stamp: %02d/%02d/%02d %02d:%02d:%02d\n", argv[2], mon1, day1, year1, hour1, min1, sec1);

	switch(client.compareDateTime(day,mon,year,hour,min,sec,day1,mon1,year1,hour1,min1,sec1)) {
	case 8: /*CAVERNnet_remoteParallelFileIOClient32_c::LATER:*/
		printf("%02d/%02d/%02d %02d:%02d:%02d is later than %02d/%02d/%02d %02d:%02d:%02d\n", mon, day, year, hour, min, sec, mon1, day1, year1, hour1, min1, sec1);
		break;

	case 7: /*CAVERNnet_remoteParallelFileIOClient32_c::EARLIER:*/
		printf("%02d/%02d/%02d %02d:%02d:%02d is earlier than %02d/%02d/%02d %02d:%02d:%02d\n", mon, day, year, hour, min, sec, mon1, day1, year1, hour1, min1, sec1);
		break;

	case 9: /*CAVERNnet_remoteParallelFileIOClient32_c::SAME:*/
		printf("%02d/%02d/%02d %02d:%02d:%02d is same as %02d/%02d/%02d %02d:%02d:%02d\n", mon, day, year, hour, min, sec, mon1, day1, year1, hour1, min1, sec1);
		break;
	}
    client.showStats("RemoteParallelFileIOClient_32_monitoring", "some_local_data");
    printf("\n");
}
