/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERN.hxx"

int doAndReplyCallback(char* indata, int inlen,
		       char **outdata, int *outlen)
{
	printf("Doing and replying: %s\n", indata);
	*outdata = new char[256];
	strcpy(*outdata,"HELLO THERE\n");
	*outlen = strlen(*outdata) + 1;
	return 0;
}

int doOnceCallback(char* indata, int inlen,
		       char **outdata, int *outlen)
{
	printf("Doing once: %s\n",indata);
	return 0;
}

main(int argc, char** argv)
{
	CAVERNinit();
    CAVERNnet_rpcManager_c rpcManager;
	rpcManager.init();
	rpcManager.manage("DO and REPLY", doAndReplyCallback);
	rpcManager.manage("DO ONCE", doOnceCallback);

	while(1) {
		rpcManager.process();

        //For an instantaneous display of performance monitoring stats
        rpcManager.showStats("Monitoring_in_rpcManager", "Some_remote_data");

        sleep(1);    
	}
	return 0;
}
