/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/
#include "CAVERN.hxx"
#ifdef WIN32
#include <winsock.h>
#else
#include <unistd.h>
#endif
#include "CAVERNnet_perfClient_c.hxx"

#define BUFFER_SIZE 1024
main(int argc, char** argv)
{
	CAVERNinit();

	CAVERNnet_perfDaemonClient_c aClient(1); // Specify this is a perfclient

	if (argc == 1) {
		printf("Usage: %s <perfdaemon_ip>\n",argv[0]);
		exit(1);
	}

	if (aClient.connectToServer(argv[1])  == CAVERNnet_perfDaemonClient_c::FAILED) {
		printf("Cannot connect to perfdaemon\n");
		exit(1);
	}
	
	/// Enter a loop and read incoming netlogger traces.
	char *data = new char[BUFFER_SIZE];
	int size = BUFFER_SIZE;
    printf("\nQOSIMOTO Client waiting for data:\n%s\n",data);
	while(1) {
		data = NULL;
		aClient.read(&data, &size, CAVERNnet_perfDaemonClient_c::NON_BLOCKING);
		if (data) 
        {
			printf("\nQOSIMOTO Client printing data:\n%s\n",data);
			delete data;
		}
	}

}

