/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

/* This demonstrates the use of the CAVERNnet_tcpReflector_c class.
 * This server accepts N client connections.
 * It receives data from the clients and reflects it to all other connected clients.
 */

#include "CAVERN.hxx"

#include <stdlib.h>
#ifdef WIN32
#include <string.h>
#else
#include <strings.h>
#endif


CAVERNnet_tcpReflector_c *server;

void main (int argc, char *argv[])
{

	CAVERNinit();

	server = new CAVERNnet_tcpReflector_c;
	if (server->init() != CAVERNnet_tcpReflector_c::OK)	{
		exit(1);
	}
    /*to create a logfile for storing performance monitoring results 
    */
    int fileOpenOK =0;
    FILE* filePtr;
    filePtr = fopen("TCPREFLECTOR.log", "a");
    if (filePtr)
    {        
        fileOpenOK =1;
    }

	void newclientcallback(CAVERNnet_tcpReflectorClient_c *newClient, void* userData);
	server->interceptNewConnection(newclientcallback, NULL);

	while(1) {
		server->checkForNewClients();
		server->process();
        //Uncoment this for an instantaneous display of performance monitoring statistics
        //	server->showStats("Remote_data_monitored","Some_remote_data");
        if (fileOpenOK)
                    {
                        if (server->logStats("CAVE_avatar_on_some_machine", "New_avatar_entered", filePtr) != CAVERNnet_perfMonitor_c::OK)
                            printf("\nlogStats Failed!\n");
                    }  
        sleep(1);        
	}
}

void newclientcallback(CAVERNnet_tcpReflectorClient_c *newClient, void* userData)
{
	char name[256];
	newClient->getRemoteIP(name);
	printf("NEW CLIENT: %s\n",name);

}


