/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/
#include "CAVERN.hxx"

main(int argc, char** argv)
{
	CAVERNinit();

	CAVERNnet_udpReflector_c *reflector = new CAVERNnet_udpReflector_c;

	reflector->setIncomingPort(atoi(argv[1]));
	//	reflector->setForcedDestination(argv[2],atoi(argv[3]));
	//	reflector->setMulticastAddress(argv[4],atoi(argv[5]));
	reflector->init();
    reflector->enableInstrumentation();
    
	double ct, lt;
	lt = 0;
    int perfDaemonStatus =1;
    if (argc > 2 && reflector->initSendStats(argv[2])!= CAVERNnet_perfMonitor_c::OK)
        {
            printf("\nCannot connect to the perfDaemon\n");
            exit(1);
        }
    if (argc <= 2)
        perfDaemonStatus =0;            //No perfDaemon IP given
	
    while(1) {
		reflector->process();
		ct = reflector->getTimeInSecs();
		if ((ct - lt) >5.0) {
			reflector->showStats("Monitoring_in_udpReflector", "Testing_some_new_data");
            if (perfDaemonStatus)
            {
                if (reflector->sendStats("VIDEO_AVATAR_ON_CRAY", "UDP_TRACKER_DATA")!=CAVERNnet_perfMonitor_c::OK)
                    printf("\nSendStats failed!\n");
            }
            lt = ct;
		}
   	}
    reflector->exitSendStats();
}
