/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

//Demo program that creates a thread and takes care of mutual exclusion

#include "CAVERN.hxx"

#ifdef WIN32
#include <string.h>
#else
#include <strings.h>
#endif
#include <stdlib.h>

#ifdef WIN32
#define sleep(seconds)	Sleep(seconds * 1000)
#endif

void* threadedFunction(void* data);

CAVERNts_mutex_c cavernMutex;

main(int argc, char** argv)
{
	CAVERNinit();
    CAVERNts_thread_c cavernThread;
    
    int *count = new int;
    *count =1;
    
    //This is just to turn the debugstat on for the mutex - this will print messages for debugging(turned off by default)
    
    cavernMutex.setMutexDebug(CAVERNts_mutex_c::DEBUG_ON);
    
    //loop to create 100 threads
	while(1) {
    cavernThread.create(threadedFunction, (void*) count);         
    (*count)++;
    #ifdef __sgi	
    	sginap(10);
    #endif
	
    //exit if 100 threads have been created
    if (*count >100)
        exit(0);            
	}

}

void* threadedFunction(void* data)
{
    cavernMutex.lock();               //lock mutex
    int* count = (int*) data;                   
    printf("\nThread number %d\n", *count);
    cavernMutex.unlock();            //unlock mutex
    return NULL;
}
