/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERNmisc_hash.hxx"

/* This hash function computes a 31 bit value.  The value is used to index
   the hash directory using the top n bits.  It is also used in a hash bucket
   to find the home position of the element by taking the value modulo the
   bucket hash table size. */
CAVERNmisc_hashWord_t CAVERNmisc_hash (char *key, int ksize){
	CAVERNmisc_hashWord_t value;	/* Used to compute the hash value.  */
	int   index;		/* Used to cycle through random values. */


	/* Set the initial value from key. */
	value = 0x238F13AF * ksize;
	for (index = 0; index < ksize; index++)
		value = (value + (key[index] << (index*5 % 24))) & 0x7FFFFFFF;
	
	value = (1103515243 * value + 12345) & 0x7FFFFFFF;  

	/* Return the value. */
	return((CAVERNmisc_hashWord_t) value);
}
