/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERNts_thread_c.hxx"

#if defined(WIN32) && defined(CAVERN_USE_WINDOWSTHREADS)
#include <windows.h>
#include <process.h>
#include <errno.h>
#endif

#if defined(WIN32) && defined(CAVERN_USE_WINDOWSTHREADS)
	typedef unsigned (__stdcall *THREAD_FUNC) (void *);
#endif

int CAVERNts_thread_c :: create(void *(*threaded_func)(void *), void *arg)
{
int status;
#ifdef CAVERN_USE_GLOBUS_THREADS
	return globus_thread_create(&itsThread,NULL, threaded_func, arg);
#endif
#ifdef CAVERN_USE_PTHREADS
    printf("\nCreating a thread");
    status= pthread_create(&itsThread,NULL, threaded_func, arg);
    pthread_detach(itsThread);
    return status;
#endif
#ifdef CAVERN_USE_WINDOWSTHREADS
    unsigned result = _beginthreadex(NULL, 0, 
		                             (THREAD_FUNC) threaded_func, arg,
                                     0, &itsThread);
    return (result == 0) ? errno : 0;
#endif
}

CAVERN_THREAD_T* CAVERNts_thread_c :: getThread()
{
	return &itsThread;
}

