/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#ifdef WIN32
#include <sys\timeb.h>
#include <math.h>

#include "gettimeofday.hxx"
#include "CAVERNinit.hxx"

// Note that tzp is going to be ignored in this function and only milliseconds will
// be reported instead of microseconds.
int gettimeofday(struct timeval *tp, void *tzp)
{
	if (UseFTimeOnly) { // Use _ftime. Precision is limited to milliseconds level.
	    struct _timeb t;

	    _ftime(&t);
		tp->tv_sec = t.time;
		tp->tv_usec = t.millitm * 1000;
	}
	else { // Use high performance counter. Precision is in microseconds level.
		LARGE_INTEGER endCounter;
		double extraSeconds;
		
		QueryPerformanceCounter(&endCounter);
		extraSeconds = (double) (endCounter.QuadPart - StartCounter.QuadPart) / (double) Frequency.QuadPart;
		tp->tv_sec = StartTimeVal.tv_sec + (long) floor(extraSeconds);
		tp->tv_usec = StartTimeVal.tv_usec + (long) floor((extraSeconds - floor(extraSeconds)) * 1000000);
	}

    return 0;
}
#endif
