/******************************************************************
 * CAVERNsoft
 * Copyright (C) 1994-2000 Electronic Visualization Laboratory,
 * all rights reserved
 * By Jason Leigh, Yong-joo Cho, Naveen Krishnaprasad, Chris Scharver,
 * Stuart Bailey, Atul Nayak, Shalini Venkataraman
 * University of Illinois at Chicago
 * 
 * This publication and its text and code may not be copied for commercial 
 * use without the express written permission of the University of Illinois
 * at Chicago.
 * The contributors disclaim any representation of warranty: use this
 * code at your own risk.
 * Direct questions, comments etc to cavern@evl.uic.edu
 ******************************************************************/

#include "CAVERNnet_datapack_c.hxx"
#include "CAVERNnet_udp_c.hxx"

#include <stdio.h>
#include <sys/types.h>
#include <time.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#ifdef WIN32
#include <winsock.h>
#include <sys\timeb.h>
#else
#include <sys/timeb.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/uio.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <sys/errno.h>
#include <signal.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/time.h>
#endif

class CAVERNnet_udp_c;

int _cavern_getSizeOfPerformanceMonitoringHeader() {
    CAVERNnet_datapack_c packer;
	return packer.sizeof_double();
}

void _cavern_prependPerformanceMonitoringHeader(char* newmsg, char* message, int length)
{
    //used to pack the timestamp with the message to be transmitted across the network
    CAVERNnet_datapack_c packer;
    
    //used just to find the time in Seconds
    CAVERNnet_udp_c dummyClient;

    int packingLength = length +  packer.sizeof_double();
    double timeStamp = dummyClient.getTimeInSecs();
    
    packer.initPack(newmsg, packingLength);
    packer.packDouble(timeStamp);
    packer.pack(message, length);
}

char* _cavern_allocMemForPerformanceMonitoredMesg(int length, int * newlength)
{
    CAVERNnet_datapack_c packer;
	*newlength = length + packer.sizeof_double();
	char* newmsg = new char[*newlength];
	return newmsg;
}

	
void _cavern_unprependPerformanceMonitoringHeader(double *remoteTimeStamp, double *inlatency, char* newmsg, int newlen,  char* umessage, int *ulen)
{
	if (newlen <=0) return;

    //used just to find the time in Seconds
    CAVERNnet_udp_c dummyClient;

    //used to unpack the timestamp from the buffer read
    CAVERNnet_datapack_c packer;

    int realSize = newlen - packer.sizeof_double();
    double localTimeStamp = dummyClient.getTimeInSecs();
    packer.initUnpack(newmsg,newlen);
    packer.unpackDouble(remoteTimeStamp);
    packer.unpack(umessage, realSize);    
	*inlatency = fabs(localTimeStamp - *remoteTimeStamp) ;
	*ulen = realSize;
}

